#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>

#include <openssl/bio.h>
#include <openssl/x509.h>
#include <openssl/pem.h>
#include <openssl/err.h>
#include <openssl/evp.h>

#include <opensc/pkcs15.h>
#include <opensc/opensc.h>

int print_pem_object(const u8 *data, size_t data_len);
int connect_card(sc_context_t *ctx, sc_card_t **cardp,int reader_id, int slot_id, int wait, int quiet);
int sign(struct sc_pkcs15_object *obj, unsigned char *hash);
int get_key(unsigned int usage, sc_pkcs15_object_t **result);
int p15sign(unsigned char *hash);
int p15getcert(unsigned char *id_cert);
int p15getlistcert();
int connect_pcsc();
int mysign(char *infile, char* signerfile);

#define SSL_SIG_LENGTH  36
#define EVP_PKEY_RSA_method2    RSA_sign2,RSA_verify, {EVP_PKEY_RSA,EVP_PKEY_RSA2,0,0}

int RSA_eay_private_encrypt2(int flen, const unsigned char *from, unsigned char *to, RSA *rsa, int padding);
int RSA_sign2(int type, const unsigned char *m, unsigned int m_len,unsigned char *sigret, unsigned int *siglen, RSA *rsa);



